﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using UnityEngine.UI;

public class RabboniConsole : MonoBehaviour
{
    public string[] DeviceName;
	public string SubscribeServiceUUID = "1600";
	public string SubscribeCharacteristic = "1601";
	
	public string PrefsServiceUUID = "fff0";
	public string PrefsCharacteristic = "fff6";
	
	public bool isIntialized;
	public GameObject initializePanel;
	public GameObject initializeBtn;
	public Text statusText;
	
	public Dictionary<string, RabboniModule> moduleDic = new Dictionary<string, RabboniModule>();
	
	
	public byte[] StringToByteArray(string hex)
	{
		int NumberChars = hex.Length;
		byte[] bytes = new byte[NumberChars / 2];
		for (int i = 0; i < NumberChars; i += 2)
		{
			bytes[i / 2] = System.Convert.ToByte(hex.Substring(i, 2), 16);
		}
		return bytes;
	}
	
	public string ByteArrayToString(byte[] ba)
	{
	  return System.BitConverter.ToString(ba).Replace("-","");
	}
	
	public string FullUUID (string uuid)
	{
		return "0000" + uuid + "-0000-1000-8000-00805F9B34FB";
	}
	
	public bool IsEqual(string uuid1, string uuid2)
	{
		if (uuid1.Length == 4)
			uuid1 = FullUUID (uuid1);
		if (uuid2.Length == 4)
			uuid2 = FullUUID (uuid2);

		return (uuid1.ToUpper().Equals(uuid2.ToUpper()));
	}
	
	void Start()
    {
		Initialize();
    }	
	
	public void Initialize()
	{
		isIntialized = false;
		initializeBtn.SetActive(false);
		statusText.text = "正在初始化藍牙...";
		
		BluetoothLEHardwareInterface.Initialize (true, false, () => {
			
			initializePanel.SetActive(false);
			
			isIntialized = true;

		}, (error) => {
			
			statusText.text = "初始化失敗，請檢察藍牙是否開啟";
			initializePanel.SetActive(true);
			initializeBtn.SetActive(true);
			
		});
	}
}
